## openjdk-21 21.0.7+6~us1

=== test/jdk/performance/client/SwingMark/Makefile ===
#
# Copyright (c) 2023, Oracle and/or its affiliates. All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
#   - Redistributions of source code must retain the above copyright
#     notice, this list of conditions and the following disclaimer.
#
#   - Redistributions in binary form must reproduce the above copyright
#     notice, this list of conditions and the following disclaimer in the
#     documentation and/or other materials provided with the distribution.
#
#   - Neither the name of Oracle nor the names of its
#     contributors may be used to endorse or promote products derived
#     from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
# IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
# THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
# PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT OWNER OR
# CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
# EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
# PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
# LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
# NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

SOURCEPATH=src
CLASSES=build
DIST=dist
RESOURCES=resources

SWINGMARK_CLASSES = \
	$(CLASSES)/AbstractSwingTest.class \
	$(CLASSES)/AdvancedTextAreaTest.class \
	$(CLASSES)/InternalFrameTest.class \
	$(CLASSES)/JMTest_01.class \
	$(CLASSES)/JMTest_02.class \
	$(CLASSES)/JMTest_03.class \
	$(CLASSES)/JMTest_04.class \
	$(CLASSES)/JMTest_05.class \
	$(CLASSES)/LabelTest.class \
	$(CLASSES)/ListTest.class \
	$(CLASSES)/MenuTest.class \
	$(CLASSES)/NullRunnable.class \
	$(CLASSES)/SliderTest.class \
	$(CLASSES)/SwingMark.class \
	$(CLASSES)/SwingMarkPanel.class \
	$(CLASSES)/TableColMoveTest.class \
	$(CLASSES)/TableColTest.class \
	$(CLASSES)/TableRowTest.class \
	$(CLASSES)/TableScrollTest.class \
	$(CLASSES)/TextAreaTest.class \
	$(CLASSES)/TextPaneTest.class \
	$(CLASSES)/TreeTest.class \
	$(CLASSES)/TypingTest.class \
        $(CLASSES)/resources/TableRowTest.class \
        $(CLASSES)/resources/TableRowTest_ja.class

SWINGMARK_RESOURCES = \
	$(CLASSES)/resources/TestList.txt \
	$(CLASSES)/resources/JMTest_04.properties \
	$(CLASSES)/resources/JMTest_04_ja.properties \
	$(CLASSES)/resources/ListTest.properties \
	$(CLASSES)/resources/ListTest_ja.properties \
	$(CLASSES)/resources/TextAreaTest.properties \
	$(CLASSES)/resources/TextAreaTest_ja.properties

all: mkdirs SwingMark.jar

run: mkdirs SwingMark.jar
	cd $(DIST) && java -jar SwingMark.jar -q

SwingMark.jar: \
	$(SWINGMARK_CLASSES) \
	$(SWINGMARK_RESOURCES) \
	$(CLASSES)/swingmark.manifest
	jar cvmf $(CLASSES)/swingmark.manifest $(DIST)/SwingMark.jar -C $(CLASSES) .

$(CLASSES)/swingmark.manifest:
	echo "Main-Class: SwingMark" > $@

$(DIST):
	mkdir $(DIST)

$(CLASSES):
	mkdir $(CLASSES)

mkdirs: $(DIST) $(CLASSES)

$(CLASSES)/%.class: $(SOURCEPATH)/%.java
	javac -d $(CLASSES) -sourcepath $(SOURCEPATH) $<

$(CLASSES)/resources/%.properties: $(SOURCEPATH)/resources/%.properties
	cp -r $< $@

$(CLASSES)/resources/TestList.txt: $(SOURCEPATH)/resources/TestList.txt
	cp -r $< $@
	
clean:
	rm -rf $(CLASSES)
	rm -rf $(DIST)

## openjdk-21 21~14ea~us1

=== debian/changelog ===
openjdk-21 (21~14ea~us1-0ubuntu1) lunar; urgency=medium

  * OpenJDK 21 snapshot, Build 14.
  * d/copyright, d/watch: implement uscan repackaging (LP: #2011749).
  * d/rules: use --with-debug-symbols=none (LP: #2003820).

 -- Vladimir Petko <vladimir.petko@canonical.com>  Fri, 17 Mar 2023 13:31:13 +1300

openjdk-21 (21~7ea-1ubuntu1) lunar; urgency=medium

  * debian/JB-jre-headless.postinst.in: trigger ca-certificates-java after jre
    is set up.

 -- Vladimir Petko <vladimir.petko@canonical.com>  Wed, 01 Mar 2023 21:34:32 +1300

openjdk-21 (21~7ea-1) unstable; urgency=medium

  * OpenJDK 21 snapshot, build 7.
  * Don't build zero on ppc64el for now, see JDK-8298655.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 26 Jan 2023 10:32:21 +0100

openjdk-21 (21~3ea-2) unstable; urgency=medium

  * Fix autopkg test dependencies.

 -- Matthias Klose <doko@debian.org>  Sat, 24 Dec 2022 15:35:45 +0100

openjdk-21 (21~3ea-1) unstable; urgency=medium

  * OpenJDK 21 snapshot, build 3.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 22 Dec 2022 21:06:42 +0100

openjdk-21 (21~1ea-1) unstable; urgency=medium

  * OpenJDK 21 snapshot, build 1.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 12 Dec 2022 14:14:44 +0100

openjdk-20 (20~26ea-1) unstable; urgency=medium

  * OpenJDK 20 snapshot, build 26 (rampdown phase one).
  * Handle jtreg package name for backports.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 12 Dec 2022 12:34:21 +0100

openjdk-20 (20~20ea-1) unstable; urgency=medium

  * OpenJDK 20 snapshot, build 20.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 21 Oct 2022 10:28:19 +0200

openjdk-20 (20~17ea-2) unstable; urgency=medium

  * Also include the classlist file for zero builds.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 03 Oct 2022 11:18:06 +0200

openjdk-20 (20~17ea-1) unstable; urgency=medium

  * OpenJDK 20 snapshot, build 17.
  * Refresh patches.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 29 Sep 2022 19:40:13 +0200

openjdk-19 (19+36-2) unstable; urgency=medium

  * Enable hotspot on riscv64. Closes: #1020545.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 28 Sep 2022 16:16:51 +0200

openjdk-19 (19+36-1) unstable; urgency=medium

  * OpenJDK 19 release.
  * Bump standards version.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 23 Sep 2022 14:55:13 +0200

openjdk-19 (19~32ea-1) unstable; urgency=medium

  * OpenJDK 19 snapshot, build 32.
  * Re-enable running the test suite.
  * Only try to re-run failed tests once instead of three times.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 22 Jul 2022 10:25:56 +0200

openjdk-19 (19~31ea-1) unstable; urgency=medium

  * OpenJDK 19 snapshot, build 31.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 17 Jul 2022 11:04:08 +0200

openjdk-19 (19~23ea-1) unstable; urgency=medium

  * OpenJDK 19 snapshot, build 23.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 19 May 2022 11:55:51 +0200

openjdk-19 (19~20ea-1) unstable; urgency=medium

  * OpenJDK 19 snapshot, build 20.
  * Refresh patches.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 03 May 2022 18:32:32 +0200

openjdk-18 (18~36ea-1) unstable; urgency=medium

  * OpenJDK 18 snapshot, build 36 (first release candidate).

 -- Matthias Klose <doko@ubuntu.com>  Thu, 17 Feb 2022 09:22:24 +0100

openjdk-18 (18~32ea-1) unstable; urgency=medium

  * OpenJDK 18 snapshot, build 32.
  * Add jwebserver into the openjdk-jdk-headless package.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 21 Jan 2022 11:45:56 +0100

openjdk-18 (18~20ea-1) unstable; urgency=medium

  * OpenJDK 18 snapshot, build 20.
  * Bump standards version.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 21 Oct 2021 08:36:16 +0200

openjdk-18 (18~15ea-4) unstable; urgency=medium

  * Fix installation of the zero VM, now installed as zero, not as server.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 17 Sep 2021 18:43:49 +0200

openjdk-18 (18~15ea-1) unstable; urgency=medium

  * OpenJDK 18 snapshot, build 15.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 16 Sep 2021 10:10:47 +0200

openjdk-18 (18~12ea-1) unstable; urgency=medium

  * OpenJDK 18 snapshot, build 12.
  * Encode the early-access status into the package version.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 26 Aug 2021 12:46:22 +0200

openjdk-18 (18~2-1) experimental; urgency=medium

  * OpenJDK 18 snapshot, build 2.
  * Only build using lto with GCC 11.
  * Build using GCC 11 in recent distributions.
  * Remove rimd, removed upstream.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 17 Jun 2021 15:00:57 +0200

openjdk-17 (17~24-1) unstable; urgency=medium

  * OpenJDK 17 snapshot, build 24.
  * Drop the work around for JDK 8211105.
  * Remove jaotc (the experimental JIT compiler), removed upstream.
  * Add an (unapplied) patch to replace OASIS header files with ones
    imported from NSPR and NSS. See #985765.  Not reviewed, not applying.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 27 May 2021 11:26:59 +0200

openjdk-17 (17~19-1) unstable; urgency=high

  * OpenJDK 17 snapshot, build 19.
    - Fix JDK-8250568: Less ambiguous processing (CVE-2021-2161).
    - Fix JDK-8249906: Enhance opening JARs (CVE-2021-2163).

 -- Matthias Klose <doko@ubuntu.com>  Thu, 22 Apr 2021 09:51:43 +0200

openjdk-17 (17~17-1) unstable; urgency=medium

  * OpenJDK 17 snapshot, build 17.
  * Refresh patches.
  * Prefer to build using openjdk-17 instead of -16. Closes: #986526.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 08 Apr 2021 09:37:40 +0200

openjdk-17 (17~15-1) unstable; urgency=medium

  * OpenJDK 17 snapshot, build 15.
  * Fix another upstream typo to build with external harfbuzz. Closes: #985668.
  * Disable running the tests on mipsel and mips64el.  Times out, and if it
    succeeds, it taken at least five days to run.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 25 Mar 2021 10:31:15 +0100

openjdk-17 (17~14-1) unstable; urgency=medium

  * OpenJDK 17 snapshot, build 14.
  * Don't use the triplet-prefixed binutils tools for backports.
  * Simplify compiler selection for backports.
  * Fix build with older glibc versions. See JDK-8262501.


=== debian/control ===
Source: openjdk-21
Section: java
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: OpenJDK Team <openjdk-21@packages.debian.org>
Uploaders: Matthias Klose <doko@ubuntu.com>
Build-Depends: debhelper (>= 11),
  m4, lsb-release, zip, unzip,
  sharutils, gawk, cpio, pkg-config, procps, wdiff, fastjar (>= 2:0.96-0ubuntu2),
  time, strip-nondeterminism, debugedit (>= 4.16),
  file,
  autoconf, automake, autotools-dev, ant, ant-optional,
  g++-12 <!cross>,
  openjdk-20-jdk-headless:native | openjdk-21-jdk-headless:native,
  libxtst-dev, libxi-dev, libxt-dev, libxaw7-dev, libxrender-dev, libcups2-dev, libasound2-dev, liblcms2-dev, libfreetype6-dev (>= 2.2.1), libxinerama-dev, libkrb5-dev, xsltproc, libpcsclite-dev, libxrandr-dev, libelf-dev, libfontconfig1-dev, libgtk2.0-0 | libgtk-3-0, libharfbuzz-dev,
  libffi-dev,
  zlib1g-dev:native, zlib1g-dev, libattr1-dev, libpng-dev, libjpeg-dev, libgif-dev, 
  libnss3-dev (>= 2:3.17.1),
  openjdk-21-jdk-headless <cross>,
Build-Depends-Indep: graphviz, pandoc,
Rules-Requires-Root: no
Standards-Version: 4.6.1
Homepage: https://openjdk.java.net/
Vcs-Browser: https://salsa.debian.org/openjdk-team/openjdk
Vcs-Git: https://salsa.debian.org/openjdk-team/openjdk.git

Package: openjdk-21-jdk-headless
Architecture: alpha amd64 armel armhf arm64 i386 ia64 mips mipsel mips64 mips64el powerpc ppc64 ppc64el m68k riscv64 sh4 sparc sparc64 s390x x32
Multi-Arch: same
Pre-Depends: ${dpkg:Depends}
Depends: openjdk-21-jre-headless (= ${binary:Version}),
  ${shlibs:Depends}, ${misc:Depends}
Suggests: openjdk-21-demo, openjdk-21-source
Provides: java-sdk-headless, java2-sdk-headless,
  java5-sdk-headless, java6-sdk-headless,
  java7-sdk-headless, java8-sdk-headless,
  java9-sdk-headless, java10-sdk-headless,
  java11-sdk-headless, java12-sdk-headless,
  java13-sdk-headless, java14-sdk-headless, java15-sdk-headless,
  java16-sdk-headless, java17-sdk-headless,
  java18-sdk-headless, java19-sdk-headless,
  java20-sdk-headless, java21-sdk-headless,
  java-compiler
Breaks: openjdk-17-jre-headless (<< 17~10)
Replaces: openjdk-17-jre-headless (<< 17~10)
Description: OpenJDK Development Kit (JDK) (headless)
 OpenJDK is a development environment for building applications,
 applets, and components using the Java programming language.

Package: openjdk-21-jre-headless
Architecture: alpha amd64 armel armhf arm64 i386 ia64 mips mipsel mips64 mips64el powerpc ppc64 ppc64el m68k riscv64 sh4 sparc sparc64 s390x x32
Multi-Arch: same
Pre-Depends: ${dpkg:Depends}
Depends: ${jredefault:Depends}, ${cacert:Depends},
  ${jcommon:Depends}, ${dlopenhl:Depends},
  ${mountpoint:Depends},
  ${shlibs:Depends}, ${misc:Depends}
Recommends: ${dlopenhl:Recommends}
Suggests: libnss-mdns,
  fonts-dejavu-extra,
  fonts-ipafont-gothic, fonts-ipafont-mincho, fonts-wqy-microhei | fonts-wqy-zenhei, fonts-indic,
Provides: java-runtime-headless, java2-runtime-headless,
  java5-runtime-headless, java6-runtime-headless,
  java7-runtime-headless, java8-runtime-headless,
  java9-runtime-headless, java10-runtime-headless,
  java11-runtime-headless, java12-runtime-headless,
  java13-runtime-headless, java14-runtime-headless, java15-runtime-headless,
  java16-runtime-headless, java17-runtime-headless,
  java17-runtime-headless, java19-runtime-headless,
  java20-runtime-headless, java21-runtime-headless,
  ${defaultvm:Provides}, ${jvm:Provides}
Breaks: ${jrehl:Breaks}
Conflicts: oracle-java11-installer, openjdk-11-jdk-headless (<< 11~18-2)
Replaces: openjdk-11-jdk-headless (<< 11~18-2)
Description: OpenJDK Java runtime, using ${vm:Name} (headless)
 Minimal Java runtime - needed for executing non GUI Java programs,
 using ${vm:Name}.

Package: openjdk-21-jdk
Architecture: alpha amd64 armel armhf arm64 i386 ia64 mips mipsel mips64 mips64el powerpc ppc64 ppc64el m68k riscv64 sh4 sparc sparc64 s390x x32
Multi-Arch: same
Pre-Depends: ${dpkg:Depends}
Depends: openjdk-21-jre (= ${binary:Version}),
  openjdk-21-jdk-headless (= ${binary:Version}),
  ${shlibs:Depends}, ${misc:Depends}
Recommends: libxt-dev
Suggests: openjdk-21-demo, openjdk-21-source, visualvm
Provides: java-sdk, java2-sdk, java5-sdk, java6-sdk,
  java7-sdk, java8-sdk, java9-sdk, java10-sdk, java11-sdk,
  java12-sdk, java13-sdk, java14-sdk, java15-sdk, java16-sdk, java17-sdk,
  java18-sdk, java19-sdk, java20-sdk, java21-sdk,
  java-compiler
Description: OpenJDK Development Kit (JDK)
 OpenJDK is a development environment for building applications,
 applets, and components using the Java programming language.

Package: openjdk-21-jre
Architecture: alpha amd64 armel armhf arm64 i386 ia64 mips mipsel mips64 mips64el powerpc ppc64 ppc64el m68k riscv64 sh4 sparc sparc64 s390x x32
Multi-Arch: same
Pre-Depends: ${dpkg:Depends}
Depends: openjdk-21-jre-headless (= ${binary:Version}),
  ${xandsound:Depends}, ${dlopenjre:Depends},
  ${shlibs:Depends}, ${misc:Depends}
Recommends: ${dlopenjre:Recommends}, ${bridge:Recommends}, fonts-dejavu-extra
Provides: java-runtime, java2-runtime,
  java5-runtime, java6-runtime,
  java7-runtime, java8-runtime,
  java9-runtime, java10-runtime,
  java11-runtime, java12-runtime,
  java13-runtime, java14-runtime, java15-runtime,
  java16-runtime, java17-runtime,
  java18-runtime, java19-runtime,
  java20-runtime, java21-runtime,
Breaks: openjdk-17-jre-headless (<< 17~10)
Replaces: openjdk-17-jre-headless (<< 17~10)
Description: OpenJDK Java runtime, using ${vm:Name}
 Full Java runtime environment - needed for executing Java GUI and Webstart
 programs, using ${vm:Name}.

Package: openjdk-21-demo
Architecture: alpha amd64 armel armhf arm64 i386 ia64 mips mipsel mips64 mips64el powerpc ppc64 ppc64el m68k riscv64 sh4 sparc sparc64 s390x x32
Priority: optional
Pre-Depends: ${dpkg:Depends}
Depends: openjdk-21-jre (= ${binary:Version}),
  ${shlibs:Depends}, ${misc:Depends}
Description: Java runtime based on OpenJDK (demos and examples)
 OpenJDK Java runtime

Package: openjdk-21-source
Architecture: all
Multi-Arch: foreign
Priority: optional
Pre-Depends: ${dpkg:Depends}
Depends: openjdk-21-jdk (>= ${source:Version}),
  ${misc:Depends}
Description: OpenJDK Development Kit (JDK) source files
 OpenJDK is a development environment for building applications,
 applets, and components using the Java programming language.
 .
 This package contains the Java programming language source files
 (src.zip) for all classes that make up the Java core API.

Package: openjdk-21-doc
Section: doc
Pre-Depends: ${dpkg:Depends}
Architecture: all
Multi-Arch: foreign
Priority: optional
Depends: ${misc:Depends},
  libjs-jquery,
  libjs-jquery-ui,
  libjs-jquery-ui-theme-base,
Suggests: openjdk-21-jdk
Description: OpenJDK Development Kit (JDK) documentation
 OpenJDK is a development environment for building applications,
 applets, and components using the Java programming language.
 .
 This package contains the API documentation.

Package: openjdk-21-dbg
Architecture: alpha amd64 armel armhf arm64 i386 ia64 mips mipsel mips64 mips64el powerpc ppc64 ppc64el m68k riscv64 sh4 sparc sparc64 s390x x32
Multi-Arch: same
Priority: optional
Section: debug
Pre-Depends: ${dpkg:Depends}
Depends: openjdk-21-jre-headless (= ${binary:Version}),
   ${misc:Depends}
Recommends: openjdk-21-jre (= ${binary:Version})
Suggests: openjdk-21-jdk (= ${binary:Version})
Conflicts: ${dbg:Conflicts}
Description: Java runtime based on OpenJDK (debugging symbols)
 OpenJDK is a development environment for building applications,
 applets, and components using the Java programming language.
 .
 This package contains the debugging symbols.

Package: openjdk-21-jre-zero
Architecture: amd64 i386 arm64 armhf ppc64 riscv64 s390x
Multi-Arch: same
Priority: optional
Pre-Depends: ${dpkg:Depends}
Depends: openjdk-21-jre-headless (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Provides: ${zerovm:Provides}
Description: Alternative JVM for OpenJDK, using Zero
 The package provides an alternative runtime using the Zero VM. Built on
 architectures in addition to the Hotspot VM as a debugging aid for those
 architectures which don't have a Hotspot VM.
 .
 The VM is started with the option `-zero'. See the README.Debian for details.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

unexport LANG LC_ALL

dh_version := $(shell dpkg-query -f '$${Version}\n' -W debhelper | sed -n 's/^\(.\).*/\1/p')

# using brace expansion and substring replacements (${var:0:2}).
SHELL = /bin/bash

# use gnu time in verbose mode if available, otherwise default to the shell builtin
ifneq (,$(wildcard /usr/bin/time))
  TIME = /usr/bin/time -v
else
  TIME = time
endif

vafilt = $(subst $(2)=,,$(filter $(2)=%,$(1)))

DPKG_VARS		:= $(shell dpkg-architecture)
DEB_HOST_GNU_TYPE	?= $(call vafilt,$(DPKG_VARS),DEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE	?= $(call vafilt,$(DPKG_VARS),DEB_BUILD_GNU_TYPE)
DEB_HOST_ARCH		?= $(call vafilt,$(DPKG_VARS),DEB_HOST_ARCH)
DEB_BUILD_ARCH		?= $(call vafilt,$(DPKG_VARS),DEB_BUILD_ARCH)
DEB_HOST_ARCH_CPU	?= $(call vafilt,$(DPKG_VARS),DEB_HOST_ARCH_CPU)
DEB_HOST_MULTIARCH	?= $(call vafilt,$(DPKG_VARS),DEB_HOST_MULTIARCH)

PATH := $(CURDIR)/bin:$(PATH)
export PATH

CHANGELOG_VARS := $(shell dpkg-parsechangelog | sed -n 's/ /_/g;/^[^_]/s/^\([^:]*\):_\(.*\)/\1=\2/p')
PKGSOURCE := $(call vafilt,$(CHANGELOG_VARS),Source)
PKGVERSION := $(call vafilt,$(CHANGELOG_VARS),Version)
PKGYEAR := $(shell echo $(call vafilt,$(CHANGELOG_VARS),Timestamp) | date --utc +%Y)

distribution := $(shell lsb_release --id --short)
distrel := $(shell lsb_release --codename --short)
derivative := $(shell if dpkg-vendor --derives-from Ubuntu; then echo Ubuntu; \
               elif dpkg-vendor --derives-from Debian; then echo Debian; \
               else echo Unknown; fi)
ifeq ($(distrel),n/a)
  distrel := sid
endif

ifneq (,$(filter $(distrel),precise))
  OBJCOPY := objcopy
  STRIP := strip
else
  OBJCOPY := $(DEB_HOST_GNU_TYPE)-objcopy
  STRIP := $(DEB_HOST_GNU_TYPE)-strip
endif

multiarch_dir = /$(DEB_HOST_MULTIARCH)

hotspot_archs	= amd64 i386 arm64 armhf ppc64 ppc64el riscv64 s390x
jtreg_archs	= $(hotspot_archs) alpha ia64 powerpc ppc64 sh4 x32
jtreg_archs	+= armel mipsel mips64el
jtreg_archs	+= riscv64

# FIXME: use bootcycle builds for zero archs?
bootcycle_build = $(if $(filter $(DEB_HOST_ARCH), $(hotspot_archs)),yes)
#bootcycle_build = $(if $(filter $(DEB_HOST_ARCH), amd64 i386),yes)
#bootcycle_build =
zbootcycle_build =
zbootcycle_build = yes
ifneq ($(DEB_HOST_ARCH),$(DEB_BUILD_ARCH))
  bootcycle_build =
  zbootcycle_build =
endif
ifneq (,$(filter nobootcycle, $(DEB_BUILD_OPTIONS)))
  bootcycle_build =
  zbootcycle_build =
endif

ifneq (,$(filter $(distrel),lucid precise quantal raring saucy trusty utopic vivid wily lenny etch squeeze wheezy jessie))
  is_default = no
else
  is_default = yes
endif

#is_upstream_release = yes

srcdir		= .
builddir	= build
zbuilddir	= build-zero

VENDOR		= openjdk
Vendor		= OpenJDK
TOP		= usr/lib/jvm
origin		= openjdk
basename	= openjdk-$(shortver)
ifneq (,$(filter $(DEB_HOST_ARCH), $(hotspot_archs)))
  priority	= $(if $(filter yes, $(is_default)),2111,2109)
  vm_name	= Hotspot JIT
else
  priority	= $(if $(filter yes, $(is_default)),2104,2103)
  vm_name	= Hotspot Zero
endif
jvmver		= 1.21.0
shortver	= 21
v_debian	:= $(shell echo $(PKGVERSION) | sed 's/ea//' | sed 's/\~us[[:digit:]]\+//')
v_upstream	:= $(shell echo $(v_debian) | sed 's/-[^-][^-]*$$//')
v_pkgrel	:= $(shell echo $(v_debian) | sed 's/^.*-//')
# FIXME. currently v_upstream like 11~4
#v_upbase	:= $(word 1, $(subst +, , $(v_upstream)))
#v_upbuild	:= $(word 2, $(subst +, , $(v_upstream)))
v_upbase	:= $(word 1, $(subst ~, , $(v_upstream)))
v_upbuild	:= $(word 2, $(subst ~, , $(v_upstream)))
# that should be the package version ...

#$(warning XXXXX $(v_upstream) / $(v_pkgrel) / $(v_upbase) / $(v_upbuild))

#ifneq ($(v_debian),$(v_upbase)+$(v_upbuild)-$(v_pkgrel))
#  $(error wrong version: $(v_upbase)+$(v_upbuild)-$(v_pkgrel) should be: $(v_debian))
#endif
ifneq ($(v_debian),$(v_upbase)~$(v_upbuild)-$(v_pkgrel))
  $(error wrong version: $(v_upbase)~$(v_upbuild)-$(v_pkgrel) should be: $(v_debian))
endif

ifneq (,$(DEB_HOST_MULTIARCH))
  jdirname	= java-$(shortver)-$(origin)-$(DEB_HOST_ARCH)
  jdiralias	= java-$(jvmver)-$(origin)-$(DEB_HOST_ARCH)
  basedir	= $(TOP)/$(jdirname)
  commonbasedir	= $(TOP)/java-$(shortver)-$(origin)-common
  commonbasedir	= $(basedir)
  etcdir	= etc/java-$(shortver)-$(origin)
else
  jdirname	= java-$(shortver)-$(origin)
  jdiralias	= java-$(jvmver)-$(origin)
  basedir	= $(TOP)/$(jdirname)
  commonbasedir	= $(TOP)/java-$(shortver)-$(origin)
  etcdir	= etc/$(jdirname)
endif
security	= $(etcdir)/security
ifeq ($(bootcycle_build),yes)
  sdkimg	= bootcycle-build/images/jdk
  build_target	= bootcycle-images test-image
else
  sdkimg	= images/jdk
  build_target	= images test-image
endif
ifeq ($(zbootcycle_build),yes)
  zsdkimg	= bootcycle-build/images/jdk
  zbuild_target	= bootcycle-images test-image
else
  zsdkimg	= images/jdk
  zbuild_target	= images test-image
endif

# Support parallel=<n> in DEB_BUILD_OPTIONS (see #209008)
COMMA=,
SPACE = $(EMPTY) $(EMPTY)
ifneq (,$(filter parallel=%,$(subst $(COMMA), ,$(DEB_BUILD_OPTIONS))))
  NJOBS = $(subst parallel=,,$(filter parallel=%,$(subst $(COMMA), ,$(DEB_BUILD_OPTIONS))))
endif

ifneq (,$(filter $(distrel), sid bookworm bullseye focal jammy kinetic))
  jtreg_pkg = jtreg6
else ifneq (,$(filter $(distrel), sid bookworm bullseye))
  jtreg_pkg = jtreg
else
  jtreg_pkg =
endif

with_check = $(if $(findstring nocheck, $(DEB_BUILD_OPTIONS)),,yes)
ifneq (,$(filter $(DEB_HOST_ARCH), alpha armel mipsel mips64el riscv64))
  with_check = disabled running check on $(DEB_HOST_ARCH)
endif
# no jtreg backport yet
ifneq (,$(filter $(distrel), precise trusty xenial bionic))
  with_check = disabled for $(distrel), no $(jtreg_pkg)
endif
#with_check = disabled, more recent jtreg needed

with_docs = $(if $(findstring nodoc, $(DEB_BUILD_OPTIONS)),,yes)
ifneq (,$(filter $(distrel), precise trusty))
  with_docs =
endif
with_check = disabled for this upload

with_wqy_zenhai = $(if $(filter $(distrel),lenny),,yes)

arch_map	:= alpha=alpha arm=arm armel=arm armhf=arm arm64=aarch64 amd64=amd64 hppa=parisc i386=i586 m68k=m68k mips=mips mipsel=mipsel mips64=mips64 mips64el=mips64el powerpc=ppc ppc64=ppc64 ppc64el=ppc64le riscv64=riscv64 sparc=sparc sparc64=sparcv9 sh4=sh s390x=s390x ia64=ia64 x32=x32

jvmarch		:= $(strip $(patsubst $(DEB_HOST_ARCH_CPU)=%, %, \
			$(filter $(DEB_HOST_ARCH_CPU)=%, $(arch_map))))
ifeq ($(DEB_HOST_ARCH),x32)
  jvmarch := x32
endif

default_vm = $(if $(filter $(DEB_HOST_ARCH), $(hotspot_archs)),hotspot,zero)

any_archs = alpha amd64 armel armhf arm64 i386 ia64 mips mipsel mips64 mips64el powerpc ppc64 ppc64el m68k riscv64 sh4 sparc sparc64 s390x x32

altzero_archs = $(hotspot_archs)
ifneq (,$(filter $(distrel),trusty))
  altzero_archs := $(filter-out arm64, $(altzero_archs))
endif
# see https://bugs.openjdk.org/browse/JDK-8298655
altzero_archs := $(filter-out ppc64el, $(altzero_archs))

# FIXME: https://launchpad.net/ubuntu/+source/openjdk-lts/11.0.5+6-1ubuntu1
# ftbfs on armhf, also in OpenJDK 15, now fixed in 16?
#altzero_archs := $(filter-out armhf, $(altzero_archs))

ifneq (,$(filter noaltzero, $(DEB_BUILD_OPTIONS)))
  altzero_archs =
else ifneq (,$(filter $(DEB_HOST_ARCH), $(altzero_archs)))
  alternate_vms += zero
  zero_dir = zero
endif

# needed for the jexec build
export DEBIAN_JDK_BASE_DIR := /$(basedir)

BOOTJDK_HOME := $(strip $(subst /bin/javac,, $(firstword $(wildcard \
			/usr/lib/jvm/java-18-openjdk-$(DEB_BUILD_ARCH)/bin/javac \
			/usr/lib/jvm/java-19-openjdk-$(DEB_BUILD_ARCH)/bin/javac \
		))))

ifeq ($(DEB_BUILD_ARCH),$(DEB_HOST_ARCH))
  BUILDJDK_HOME = $(CURDIR)/$(builddir)/$(sdkimg)
else
  BUILDJDK_HOME = $(BOOTJDK_HOME)
endif

ifneq (,$(filter $(distrel),saucy))
  export CC = gcc-4.8
  export CXX = g++-4.8
  bd_gcc = g++-4.8,
else ifneq (,$(filter $(distrel),utopic vivid jessie))
  export CC = gcc-4.9
  export CXX = g++-4.9
  bd_gcc = g++-4.9,
else ifneq (,$(filter $(distrel),wily))
  ifneq (,$(filter $(DEB_HOST_ARCH), $(hotspot_archs)))

=== debian/tests/control ===
Test-Command: java --version
Depends: openjdk-21-jre-headless
Restrictions: superficial

Test-Command: javac --version
Depends: openjdk-21-jdk-headless
Restrictions: superficial

#Tests: hotspot, jaxp, langtools
#Depends: @, default-jre-headless, jtreg6:native (>= 7.1.1+1-0~), testng:native, build-essential
#Restrictions: allow-stderr, skippable, flaky

#Tests: jdk
#Depends: @, default-jre-headless, jtreg6:native (>= 7.1.1+1-0~), testng:native, build-essential, xfwm4:native, xvfb, dbus-x11
#Restrictions: allow-stderr, skippable, flaky

=== debian/watch ===
version=4
opts=\
repack,\
compression=xz,\
repacksuffix=ea~us1,\
oversionmangle=s/\+/\~/,\
dversionmangle=s/~\d*\~us\d*$/\+\d*/, \
   https://github.com/openjdk/jdk/tags \
   (?:.*?/)?jdk-(21\+\d[\d]*)\.tar\.gz

## openjdk-21 21~28ea

=== debian/changelog ===
openjdk-21 (21~28ea-2) unstable; urgency=medium

  * Update VCS attributes.
  * Provide versioned java-runtime, java-runtime-headless, java-sdk
    and java-sdk-headless virtual packages (Emmanuel Bourg).
  * Add support for arc (untested), hppa (untested) and ia64.
  * Configure --with-stdc++lib=static on ia64.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 29 Jun 2023 07:21:14 +0200

openjdk-21 (21~28ea-1) unstable; urgency=medium

  * OpenJDK 21 snapshot, Build 28.
  * Add support for alpha, m68k, ppc, sh, x32.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 26 Jun 2023 07:48:49 +0200

openjdk-21 (21~27ea-4) unstable; urgency=medium

  * debian/rules: Correctly set BOOT_JDK_HOME.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 16 Jun 2023 20:53:53 +0200

openjdk-21 (21~27ea-3) unstable; urgency=medium

  * Regenerate autopkg test scripts.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 16 Jun 2023 14:51:08 +0200

openjdk-21 (21~27ea-2) unstable; urgency=medium

  * OpenJDK 21 snapshot, Build 27.

  [ Vladimir Petko ]
  * Also disable tests on trixie. No jtreg7 yet.
  * debian/copyright: Convert to a machine-readable format.
  * debian/copyright: Align excludes statement with openjdk-17.
  * debian/watch: Add ea repack suffix.
  * Fix build on mipsel and mips64el.
  * Move ct.sym from the jre into the jdk package.

  [ Matthias Klose ]
  * Enable tests for trixie and unstable.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 16 Jun 2023 08:56:39 +0200

openjdk-21 (21~26ea-2) unstable; urgency=medium

  [ Vladimir Petko ]
  * d/rules: only compile google tests when with_check is enabled,
    disable them for bullseye and jammy.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 12 Jun 2023 06:29:28 +0200

openjdk-21 (21~26ea-1) unstable; urgency=medium

  * OpenJDK 21 snapshot, Build 26.

  [ Vladimir Petko ]
  * d/p/*: refresh patches.
  * Copy OpenJDK 20 packaging changes:
    - d/rules: pack external debug symbols with build-id, do not pack duplicate
      symbols, do not strip JVM shared libraries (LP: #2012326, LP: #2016739).
    - d/{control, compat}: update debhelper-compat version, add jtreg7
      dependencies, regenerate control.
    - d/t/{jdk,hotspot,jaxp,lantools}: run tier1 and tier2 jtreg tests only,
      add test options from OpenJDK makefile.
    - d/t/*: fix test environment: add missing -nativepath (LP: #2001563).
    - d/t/jdk: provide dbus session for the window manager (LP: #2001576).
    - d/p/build_gtest.patch: build OpenJDK with the system googletest
      (LP: #2012316).
  * d/p/*: add patches for jtreg tests:
    - misalign-pointer-for-armhf.patch: packaging-specific patch to fix test
      failure introduced by d/p/m68k-support.diff.
    - log-generated-classes-test.patch: workaround JDK-8166162.
    - update-permission-test.patch: add security permissions for testng 7.
    - ldap-timeout-test-use-ip.patch, test-use-ip-address.patch:
      Ubuntu-specific patches to workaround missing DNS resolver on the build
      machines.
    - exclude_broken_tests.patch: quarantine failing tests.
  * Enable ppc64el JRE zero build as JDK-8299476 is fixed.
  * Known issues:
    - amd64: test/jdk/sun/security/pkcs11/KeyStore/CertChainRemoval.java:
      https://mail.openjdk.org/pipermail/jdk-dev/2023-May/007836.html
    - s390x: test/hotspot/jtreg/runtime/NMT/VirtualAllocCommitMerge.java:
      https://mail.openjdk.org/pipermail/hotspot-dev/2023-June/075316.html

  [ Matthias Klose ]
  * Fix jaxp.properties installation.
  * Bump standards version.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 10 Jun 2023 17:54:09 +0200

openjdk-21 (21~14ea-1) UNRELEASED; urgency=medium

  [ Vladimir Petko ]
  * OpenJDK 21 snapshot, Build 14.
  * d/copyright, d/watch: implement uscan repackaging (LP: #2011749).
  * d/rules: use --with-debug-symbols=none (LP: #2003820).
  * debian/JB-jre-headless.postinst.in: trigger ca-certificates-java after jre
    is set up.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 09 Jun 2023 17:15:22 +0200

=== debian/control ===
--- 
+++ 
@@ -1,14 +1,13 @@
 Source: openjdk-21
 Section: java
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: OpenJDK Team <openjdk-21@packages.debian.org>
+Maintainer: OpenJDK Team <openjdk-21@packages.debian.org>
 Uploaders: Matthias Klose <doko@ubuntu.com>
 Build-Depends: debhelper (>= 11),
   m4, lsb-release, zip, unzip,
   sharutils, gawk, cpio, pkg-config, procps, wdiff, fastjar (>= 2:0.96-0ubuntu2),
   time, strip-nondeterminism, debugedit (>= 4.16),
-  file,
+  jtreg7  <!nocheck>, libtestng7-java <!nocheck>, xvfb <!nocheck>, xauth <!nocheck>, xfonts-base <!nocheck>, libgl1-mesa-dri [!x32] <!nocheck>, xfwm4 <!nocheck>, x11-xkb-utils <!nocheck>, dbus-x11 <!nocheck>, libasmtools-java <!nocheck>, googletest <!nocheck>, google-mock <!nocheck>, xvfb  <!nocheck>,
   autoconf, automake, autotools-dev, ant, ant-optional,
   g++-12 <!cross>,
   openjdk-20-jdk-headless:native | openjdk-21-jdk-headless:native,
@@ -19,19 +18,19 @@
   openjdk-21-jdk-headless <cross>,
 Build-Depends-Indep: graphviz, pandoc,
 Rules-Requires-Root: no
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Homepage: https://openjdk.java.net/
-Vcs-Browser: https://salsa.debian.org/openjdk-team/openjdk
-Vcs-Git: https://salsa.debian.org/openjdk-team/openjdk.git
+Vcs-Browser: https://salsa.debian.org/openjdk-team/openjdk/tree/openjdk-21
+Vcs-Git: https://salsa.debian.org/openjdk-team/openjdk.git -b openjdk-21
 
 Package: openjdk-21-jdk-headless
-Architecture: alpha amd64 armel armhf arm64 i386 ia64 mips mipsel mips64 mips64el powerpc ppc64 ppc64el m68k riscv64 sh4 sparc sparc64 s390x x32
+Architecture: alpha amd64 arc armel armhf arm64 hppa i386 ia64 mips mipsel mips64 mips64el powerpc ppc64 ppc64el m68k riscv64 sh4 sparc sparc64 s390x x32
 Multi-Arch: same
 Pre-Depends: ${dpkg:Depends}
 Depends: openjdk-21-jre-headless (= ${binary:Version}),
   ${shlibs:Depends}, ${misc:Depends}
 Suggests: openjdk-21-demo, openjdk-21-source
-Provides: java-sdk-headless, java2-sdk-headless,
+Provides: java-sdk-headless (= ${vm:Version}), java2-sdk-headless,
   java5-sdk-headless, java6-sdk-headless,
   java7-sdk-headless, java8-sdk-headless,
   java9-sdk-headless, java10-sdk-headless,
@@ -41,14 +40,14 @@
   java18-sdk-headless, java19-sdk-headless,
   java20-sdk-headless, java21-sdk-headless,
   java-compiler
-Breaks: openjdk-17-jre-headless (<< 17~10)
-Replaces: openjdk-17-jre-headless (<< 17~10)
+Breaks: openjdk-17-jre-headless (<< 17~10), openjdk-21-jre-headless (<< 21~27ea),
+Replaces: openjdk-17-jre-headless (<< 17~10), openjdk-21-jre-headless (<< 21~27ea),
 Description: OpenJDK Development Kit (JDK) (headless)
  OpenJDK is a development environment for building applications,
  applets, and components using the Java programming language.
 
 Package: openjdk-21-jre-headless
-Architecture: alpha amd64 armel armhf arm64 i386 ia64 mips mipsel mips64 mips64el powerpc ppc64 ppc64el m68k riscv64 sh4 sparc sparc64 s390x x32
+Architecture: alpha amd64 arc armel armhf arm64 hppa i386 ia64 mips mipsel mips64 mips64el powerpc ppc64 ppc64el m68k riscv64 sh4 sparc sparc64 s390x x32
 Multi-Arch: same
 Pre-Depends: ${dpkg:Depends}
 Depends: ${jredefault:Depends}, ${cacert:Depends},
@@ -59,7 +58,7 @@
 Suggests: libnss-mdns,
   fonts-dejavu-extra,
   fonts-ipafont-gothic, fonts-ipafont-mincho, fonts-wqy-microhei | fonts-wqy-zenhei, fonts-indic,
-Provides: java-runtime-headless, java2-runtime-headless,
+Provides: java-runtime-headless (= ${vm:Version}), java2-runtime-headless,
   java5-runtime-headless, java6-runtime-headless,
   java7-runtime-headless, java8-runtime-headless,
   java9-runtime-headless, java10-runtime-headless,
@@ -77,7 +76,7 @@
  using ${vm:Name}.
 
 Package: openjdk-21-jdk
-Architecture: alpha amd64 armel armhf arm64 i386 ia64 mips mipsel mips64 mips64el powerpc ppc64 ppc64el m68k riscv64 sh4 sparc sparc64 s390x x32
+Architecture: alpha amd64 arc armel armhf arm64 hppa i386 ia64 mips mipsel mips64 mips64el powerpc ppc64 ppc64el m68k riscv64 sh4 sparc sparc64 s390x x32
 Multi-Arch: same
 Pre-Depends: ${dpkg:Depends}
 Depends: openjdk-21-jre (= ${binary:Version}),
@@ -85,7 +84,7 @@
   ${shlibs:Depends}, ${misc:Depends}
 Recommends: libxt-dev
 Suggests: openjdk-21-demo, openjdk-21-source, visualvm
-Provides: java-sdk, java2-sdk, java5-sdk, java6-sdk,
+Provides: java-sdk (= ${vm:Version}), java2-sdk, java5-sdk, java6-sdk,
   java7-sdk, java8-sdk, java9-sdk, java10-sdk, java11-sdk,
   java12-sdk, java13-sdk, java14-sdk, java15-sdk, java16-sdk, java17-sdk,
   java18-sdk, java19-sdk, java20-sdk, java21-sdk,
@@ -95,14 +94,14 @@
  applets, and components using the Java programming language.
 
 Package: openjdk-21-jre
-Architecture: alpha amd64 armel armhf arm64 i386 ia64 mips mipsel mips64 mips64el powerpc ppc64 ppc64el m68k riscv64 sh4 sparc sparc64 s390x x32
+Architecture: alpha amd64 arc armel armhf arm64 hppa i386 ia64 mips mipsel mips64 mips64el powerpc ppc64 ppc64el m68k riscv64 sh4 sparc sparc64 s390x x32
 Multi-Arch: same
 Pre-Depends: ${dpkg:Depends}
 Depends: openjdk-21-jre-headless (= ${binary:Version}),
   ${xandsound:Depends}, ${dlopenjre:Depends},
   ${shlibs:Depends}, ${misc:Depends}
 Recommends: ${dlopenjre:Recommends}, ${bridge:Recommends}, fonts-dejavu-extra
-Provides: java-runtime, java2-runtime,
+Provides: java-runtime (= ${vm:Version}), java2-runtime,
   java5-runtime, java6-runtime,
   java7-runtime, java8-runtime,
   java9-runtime, java10-runtime,
@@ -118,7 +117,7 @@
  programs, using ${vm:Name}.
 
 Package: openjdk-21-demo
-Architecture: alpha amd64 armel armhf arm64 i386 ia64 mips mipsel mips64 mips64el powerpc ppc64 ppc64el m68k riscv64 sh4 sparc sparc64 s390x x32
+Architecture: alpha amd64 arc armel armhf arm64 hppa i386 ia64 mips mipsel mips64 mips64el powerpc ppc64 ppc64el m68k riscv64 sh4 sparc sparc64 s390x x32
 Priority: optional
 Pre-Depends: ${dpkg:Depends}
 Depends: openjdk-21-jre (= ${binary:Version}),
@@ -158,7 +157,7 @@
  This package contains the API documentation.
 
 Package: openjdk-21-dbg
-Architecture: alpha amd64 armel armhf arm64 i386 ia64 mips mipsel mips64 mips64el powerpc ppc64 ppc64el m68k riscv64 sh4 sparc sparc64 s390x x32
+Architecture: alpha amd64 arc armel armhf arm64 hppa i386 ia64 mips mipsel mips64 mips64el powerpc ppc64 ppc64el m68k riscv64 sh4 sparc sparc64 s390x x32
 Multi-Arch: same
 Priority: optional
 Section: debug
@@ -175,7 +174,7 @@
  This package contains the debugging symbols.
 
 Package: openjdk-21-jre-zero
-Architecture: amd64 i386 arm64 armhf ppc64 riscv64 s390x
+Architecture: amd64 i386 arm64 armhf ppc64 ppc64el riscv64 s390x
 Multi-Arch: same
 Priority: optional
 Pre-Depends: ${dpkg:Depends}

=== debian/rules ===
--- 
+++ 
@@ -104,18 +104,24 @@
 v_debian	:= $(shell echo $(PKGVERSION) | sed 's/ea//' | sed 's/\~us[[:digit:]]\+//')
 v_upstream	:= $(shell echo $(v_debian) | sed 's/-[^-][^-]*$$//')
 v_pkgrel	:= $(shell echo $(v_debian) | sed 's/^.*-//')
-# FIXME. currently v_upstream like 11~4
+
+# uncomment for final release
 #v_upbase	:= $(word 1, $(subst +, , $(v_upstream)))
 #v_upbuild	:= $(word 2, $(subst +, , $(v_upstream)))
+
+# uncomment for pre-release
 v_upbase	:= $(word 1, $(subst ~, , $(v_upstream)))
 v_upbuild	:= $(word 2, $(subst ~, , $(v_upstream)))
 # that should be the package version ...
 
 #$(warning XXXXX $(v_upstream) / $(v_pkgrel) / $(v_upbase) / $(v_upbuild))
 
+#uncomment for final release
 #ifneq ($(v_debian),$(v_upbase)+$(v_upbuild)-$(v_pkgrel))
 #  $(error wrong version: $(v_upbase)+$(v_upbuild)-$(v_pkgrel) should be: $(v_debian))
 #endif
+
+# uncomment for pre-releases
 ifneq ($(v_debian),$(v_upbase)~$(v_upbuild)-$(v_pkgrel))
   $(error wrong version: $(v_upbase)~$(v_upbuild)-$(v_pkgrel) should be: $(v_debian))
 endif
@@ -157,20 +163,20 @@
   NJOBS = $(subst parallel=,,$(filter parallel=%,$(subst $(COMMA), ,$(DEB_BUILD_OPTIONS))))
 endif
 
-ifneq (,$(filter $(distrel), sid bookworm bullseye focal jammy kinetic))
-  jtreg_pkg = jtreg6
-else ifneq (,$(filter $(distrel), sid bookworm bullseye))
-  jtreg_pkg = jtreg
-else
-  jtreg_pkg =
+ifneq (,$(filter $(distrel), sid bookworm bullseye))
+  jtreg_pkg = jtreg# debian will have jtreg7 in jtreg package
+  testng_pkg = libtestng7-java
+else
+  jtreg_pkg = jtreg7
+  testng_pkg = libtestng7-java
 endif
 
 with_check = $(if $(findstring nocheck, $(DEB_BUILD_OPTIONS)),,yes)
-ifneq (,$(filter $(DEB_HOST_ARCH), alpha armel mipsel mips64el riscv64))
+ifneq (,$(filter $(DEB_HOST_ARCH), alpha arc hppa ia64 armel mipsel mips64el powerpc riscv64 x32))
   with_check = disabled running check on $(DEB_HOST_ARCH)
 endif
 # no jtreg backport yet
-ifneq (,$(filter $(distrel), precise trusty xenial bionic))
+ifneq (,$(filter $(distrel), precise trusty xenial bionic focal jammy bookworm bullseye))
   with_check = disabled for $(distrel), no $(jtreg_pkg)
 endif
 #with_check = disabled, more recent jtreg needed
@@ -179,11 +185,11 @@
 ifneq (,$(filter $(distrel), precise trusty))
   with_docs =
 endif
-with_check = disabled for this upload
+#with_check = disabled for this upload
 
 with_wqy_zenhai = $(if $(filter $(distrel),lenny),,yes)
 
-arch_map	:= alpha=alpha arm=arm armel=arm armhf=arm arm64=aarch64 amd64=amd64 hppa=parisc i386=i586 m68k=m68k mips=mips mipsel=mipsel mips64=mips64 mips64el=mips64el powerpc=ppc ppc64=ppc64 ppc64el=ppc64le riscv64=riscv64 sparc=sparc sparc64=sparcv9 sh4=sh s390x=s390x ia64=ia64 x32=x32
+arch_map	:= alpha=alpha arc=arc arm=arm armel=arm armhf=arm arm64=aarch64 amd64=amd64 hppa=parisc i386=i586 m68k=m68k mips=mips mipsel=mipsel mips64=mips64 mips64el=mips64el powerpc=ppc ppc64=ppc64 ppc64el=ppc64le riscv64=riscv64 sparc=sparc sparc64=sparcv9 sh4=sh s390x=s390x ia64=ia64 x32=x32
 
 jvmarch		:= $(strip $(patsubst $(DEB_HOST_ARCH_CPU)=%, %, \
 			$(filter $(DEB_HOST_ARCH_CPU)=%, $(arch_map))))
@@ -193,18 +199,12 @@
 
 default_vm = $(if $(filter $(DEB_HOST_ARCH), $(hotspot_archs)),hotspot,zero)
 
-any_archs = alpha amd64 armel armhf arm64 i386 ia64 mips mipsel mips64 mips64el powerpc ppc64 ppc64el m68k riscv64 sh4 sparc sparc64 s390x x32
+any_archs = alpha amd64 arc armel armhf arm64 hppa i386 ia64 mips mipsel mips64 mips64el powerpc ppc64 ppc64el m68k riscv64 sh4 sparc sparc64 s390x x32
 
 altzero_archs = $(hotspot_archs)
 ifneq (,$(filter $(distrel),trusty))
   altzero_archs := $(filter-out arm64, $(altzero_archs))
 endif
-# see https://bugs.openjdk.org/browse/JDK-8298655
-altzero_archs := $(filter-out ppc64el, $(altzero_archs))
-
-# FIXME: https://launchpad.net/ubuntu/+source/openjdk-lts/11.0.5+6-1ubuntu1
-# ftbfs on armhf, also in OpenJDK 15, now fixed in 16?
-#altzero_archs := $(filter-out armhf, $(altzero_archs))
 
 ifneq (,$(filter noaltzero, $(DEB_BUILD_OPTIONS)))
   altzero_archs =
@@ -217,8 +217,8 @@
 export DEBIAN_JDK_BASE_DIR := /$(basedir)
 
 BOOTJDK_HOME := $(strip $(subst /bin/javac,, $(firstword $(wildcard \
-			/usr/lib/jvm/java-18-openjdk-$(DEB_BUILD_ARCH)/bin/javac \
-			/usr/lib/jvm/java-19-openjdk-$(DEB_BUILD_ARCH)/bin/javac \
+			/usr/lib/jvm/java-21-openjdk-$(DEB_BUILD_ARCH)/bin/javac \
+			/usr/lib/jvm/java-20-openjdk-$(DEB_BUILD_ARCH)/bin/javac \
 		))))
 
 ifeq ($(DEB_BUILD_ARCH),$(DEB_HOST_ARCH))
@@ -237,3 +237,6 @@
   bd_gcc = g++-4.9,
 else ifneq (,$(filter $(distrel),wily))
   ifneq (,$(filter $(DEB_HOST_ARCH), $(hotspot_archs)))
+    export CC = $(DEB_HOST_GNU_TYPE)-gcc-5
+    export CXX = $(DEB_HOST_GNU_TYPE)-g++-5
+    # FIXME: altzero seems to build with GCC 5 on i386, amd64, ppc64el ...
